/**
 * 
 */
var bcustomSort = false;
var customSortCol = null;
var customSortColHeaderText = null;
var sortDirection = "";
var actionGridID = "";
var filIndex = [];
var newCustomFilter = false;
//Set a global variable to hold the context menu target column. According to the API, we should
//get a target in the contextClick method but it is not there.
var contextTarget = "";
var virtualAdaptor = new ej.JsonAdaptor().extend({
			init : function() {
				this.initial = true;
				this.text = /^<a .*>(.*)<\/a>$/;
				this.hrefField = [];
			},
			processQuery : function(ds, query) {
				var data = ds.dataSource.json;
				if (this.initial) {
					for (var dt = 0; dt < data.length; dt++) {
						for ( var prop in data[dt]) {
							var val = ej.getObject(prop, data[dt]);
							if ($.type(val) != "string")
								val = val.toString();
							if (val.match(this.text)) {
								//pushing the href column's field name

								this.hrefField.indexOf(prop) == -1 && this.hrefField.push(prop);
								//parse href text and create virual column- "href" + fieldName 
								ej.createObject("href" + prop, $($.parseHTML(val)).text(), data[dt]);
							}
						}
					}
					this.initial = false;
				}
				return this.base.processQuery.apply(this, [ ds, query ]);
			},
			onWhere : function(ds, e) {
				if (!ds)
					return ds;
				var proxy = this;
				return ds.filter(function(obj) {
					//check for href column and prepend the href to field
					e.field = proxy.hrefField.indexOf(e.field) != -1 ? "href" + e.field : e.field;
					return e.validate(obj);
				});
			},
			onSortBy : function(ds, e, query) {
				//check for href column and prepend the href to field
				e.fieldName = this.hrefField.indexOf(e.fieldName) != -1 ? "href" + e.fieldName : e.fieldName;
				return this.base.onSortBy(ds, e, query);
			},
		});

$.views.helpers({

	//  Calling createDurSubtotal for converting summaryValue as duration format

	getFormattedDuration : createDurSubtotal
});
function timeString2ms(a, b) {// time(HH:MM:SS.mss) // optimized

	return a = a.split('.'), // optimized
	b = a[1] * 1 || 0, // optimized
	a = a[0].split(':'), (b + (a[2] ? a[0] * 3600 + a[1] * 60 + a[2] * 1 : a[1] ? a[0] * 60 + a[1] * 1 : a[0] * 1) * 1e3) / 1000 // optimized
}

function focusout(args) {

	var cValue = timeString2ms(args.value);
	$("#" + actionGridID + "number_CustomValue1").ejNumericTextbox({
		value : cValue
	});
}
function actionbegin(args) {
	
	actionGridID = this._id;
	//Check if the filter dialog box is for a duration column
	if (args.requestType == "filterbeforeopen" && !this.changeCustomDlg && args.columnName.indexOf("duration") !== -1) {
		//Hide the default numeric input box and surface a text input box with an input mask
		$("#" + this._id + "number_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").prepend("<input type='text' class='e-msk'/>");
		$("#" + this._id + "number_CustomFDlg").find('.e-msk').ejMaskEdit({
			inputMode : "text",
			focusOut : "focusout",
			maskFormat : "9999:99:99"
		});
		$("#" + this._id + "number_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-numeric").addClass("e-hide");

		//Preventing focus for the hidden element by disable the element

		$("#" + this._id + "number_CustomDrop1_hidden").attr("disabled", "disabled");
		this.changeCustomDlg = true;

	}
	//If the previous filtered column was a duration column, the masked field will still display when
	//filtering another number column. Hide the mask field and re-surface the default field.
	if (args.requestType == "filterbeforeopen"){ 
		if (args.columnName.indexOf("duration") == -1) {
			$("#" + this._id + "number_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-mask").addClass("e-hide");
			$("#" + this._id + "number_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-numeric").removeClass("e-hide");
		}
		if (args.columnName.indexOf("time") == -1) {
			$("#" + this._id + "date_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-timewidget").addClass("e-hide");
			$("#" + this._id + "date_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-datewidget").removeClass("e-hide");
		}
	}
	//Since we are using the filtercolumn function when filtering by time, we need to set a variable
	//to prevent an infinate loop when there is a filter request on a time column
	if (args.requestType == "filterbeforeopen" && args.columnName.indexOf("time") !== -1) {
		newCustomFilter = true;
	}
	if (args.requestType == "filtering" && !ej.isNullOrUndefined(this.getColumnByField(args.currentFilteringColumn).customAttributes.type) && args.currentFilteringColumn.indexOf("time") == -1) {
		delete this._excelFilter._predicates[0];
		window.origColumn = this.model.filterSettings.filteredColumns;
		var processed = getCompanionFilter.call(this, this.model.filterSettings.filteredColumns, args.currentFilteringColumn);
		ej.merge(this.model.filterSettings.filteredColumns, processed.comp);
		this.model.filterSettings["tempfilteredColumns"] = this.model.filterSettings["tempfilteredColumns"] || [];
		ej.merge(this.model.filterSettings["tempfilteredColumns"], processed.org);
	}
	//Add the time picker dropdowns to the dialog box if the filter request is for a time column
	if (args.requestType == "filterbeforeopen" && !this.changeCustomDlg && args.columnName.indexOf("time") !== -1) {
		$("#" + this._id + "date_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").eq(0).prepend("<input id='time_customValue1' type='text' class='e-timepick'/>");
		$("#" + this._id + "date_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").eq(1).prepend("<input id='time_customValue2' type='text' class='e-timepick'/>");
		$("#" + this._id + "date_CustomFDlg").find('.e-timepick').ejTimePicker({
			create : "createTimePicker",
			close : "closeTimePicker",
			focusOut : "focusout"
		});
		$("#" + this._id + "date_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-datewidget").addClass("e-hide");
		this.changeCustomDlg = true;
	}
	//Was getting strange results when trying to use default functions to get the predicdates and operators
	//so this functionality gets the values from the dropdown boxes HTML elements and uses passes them to the 
	//filter method
	if (args.requestType == "filtering" && args.currentFilteringColumn.indexOf("time") !== -1) {
		var timeValues = $("#" + this._id + "date_CustomFDlg").find('.e-timepick');
		var operatorValues = $("#" + this._id + "date_CustomFDlg").find('.e-dropdownlist');
		var firstTime = timeValues[0].value;
		var lastTime = timeValues[1].value;
		var firstOperator = operatorValues[0].value;
		var lastOperator = operatorValues[1].value;
		var condition = null;

		if (firstTime != null) {
			firstTime = new Date("2014/03/30 " + firstTime);
		}
		if (lastTime.length > 0) {
			condition = args.predicated.condition;
			lastTime = new Date("2014/03/30 " + lastTime);
		}
		if (newCustomFilter == true) {
			newCustomFilter = false;
			$("#" + this._id).ejGrid("filterColumn", args.currentFilteringColumn, firstOperator, firstTime, "or", true);
		}
	}
	
	//If the custom dialogs have already been created when opening the filter dialog on the custom columns
	//then we need to hide the default input elements and re-surface the custom ones
	if (args.requestType == "filterbeforeopen" && this.changeCustomDlg){
		if (args.columnName.indexOf("duration") !== -1) {
			$("#" + this._id + "number_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-mask").removeClass("e-hide");
			$("#" + this._id + "number_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-numeric").addClass("e-hide");
			
		}
		if (args.columnName.indexOf("time") !== -1) {
			$("#" + this._id + "date_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-timewidget").removeClass("e-hide");
			$("#" + this._id + "date_CustomFDlg").find(".e-fields:not(.e-top)").find(".e-value").find(".e-datewidget").addClass("e-hide");
		}
		
	}
	//Clear the filtering

	if (!ej.isNullOrUndefined(args.currentFilterObject) && args.currentFilterObject[0].value == "") {
		this.model.filterSettings.filteredColumns.splice(0, 1);
	}
}
function createTimePicker(e) {
	//alert("created");
	$(this.element).val("");
}
function getCompanionFilter(cols, field, compField) {
	var column = this.getColumnByField(field), compCol = ej.getObject("customAttributes.companioncol", column), comCol = [], org = [], cField;
	if (!compCol)
		return;
	cField = compField !== true ? field : compCol;
	for (var i = 0, c; i < cols.length; i++) {
		c = cols[i];
		if (c.field == cField) {
			org.push(cols.splice(i, 1)[0]);
			comCol.push($.extend({}, c, {
				field : compField !== true ? compCol : field
			}));
		}
	}

	return {
		org : org,
		comp : comCol
	};
}

function actioncomplete(args) {
	var gridObj = $("#" + this._id).ejGrid("instance");
	if (args.requestType == "sorting") {
		var sortedCol = gridObj.getColumnByField(args.columnName);
		var customAttribs = sortedCol["customAttributes"];
		var customType = "";
		if (customAttribs != null) {
			customType = customAttribs["type"];
		}
		if (customType == "duration") {
			customSort(args, gridObj);
			return;
		} else {
			if (bcustomSort == true && args.columnName.indexOf("duration") == -1) { //Our previous sorted column was a custom sort
				//We need to remove the style (sort arrow) from the custom sorted column by setting the columns headerText back to the original state
				var colModel = args.model.columns;
				var prevSortedColIx = gridObj.getColumnIndexByField(customSortCol);
				$(gridObj.getHeaderContent().find(".e-headercelldiv")[prevSortedColIx]).find(".e-icon").replaceWith("");
			}
		}
	}
	if (args.requestType == "filterafteropen") {
		this._excelFilter._menuWrap = $("#" + this._excelFilter.id + this._excelFilter._$colType + "_MenuItem");
		var $clr = this._excelFilter._menuWrap.find("li[ejfnrole='clearfilter']")
		$clr.removeClass("e-disable-item");
		filIndex.push(this.getColumnIndexByField(args.columnName));
		filIndex = $.unique(window.filIndex);
	}
	if (args.requestType == "sorting" || args.requestType == "filtering" || (args.requestType == "refresh" && !this.initialRender)) {
		//Update the filter icon externally while performing grid actions based on filtered records
		if (args.model.filterSettings.filteredColumns.length > 0) {
			for (var i = 0; i < filIndex.length; i++)
				$(this.getHeaderContent().find(".e-filtericon")[filIndex[i]]).addClass("e-filternone");
		}
		//Remove the filter icon externally while performing grid actions based on filtered records
		if (!ej.isNullOrUndefined(args.currentFilterObject) && args.currentFilterObject[0].value == "") {
			if (args.model.filterSettings.filteredColumns.length > 0) {
				for (var i = 0; i < filIndex.length; i++)
					$(this.getHeaderContent().find(".e-filtericon")[filIndex[i]]).removeClass("e-filternone");
			}
		}

	}
	sumDurations(gridObj);
	if (this._isCaptionSummary) {
		gridObj.collapseAll();
		$(this.getContentTable().find(".e-groupcaption").find("br").replaceWith(" "));
	}
}
function createDurSubtotal(totSec) {
	var hrs = 0;
	var min = 0;
	var sec = 0;
	var totalTime = "0:00:00";

	if (totSec != 0) {
		hrs = totSec / 60 / 60;
		min = (hrs % 1) * 60;
		sec = (min % 1) * 60;
		console.log("sec = " + sec);

		hrs = Math.round(parseFloat(hrs));
		min = Math.round(parseFloat(min));
		sec = Math.round(parseFloat(sec));

		var hrsStr = hrs.toString();
		var minStr = min.toString();
		var secStr = sec.toString();

		if (minStr.length == 1) {
			minStr = "0" + minStr;
		}
		if (secStr.length == 1) {
			secStr = "0" + secStr;
		}
		totalTime = hrsStr + ":" + minStr + ":" + secStr;

	}
	return totalTime;
}
function customSort(args, gridObj) {

	var colModel = args.model.columns;
	var sortedCol = gridObj.getColumnByField(args.columnName);
	var sortedColIx = gridObj.getColumnIndexByField(args.columnName);
	//Custom attributes have been added to the columns that will require special handling
	//We use these values to for special functions (ie: sorting by the companioncol)
	var customAttribs = sortedCol.customAttributes;
	var companionCol = customAttribs.companioncol;
	var resort = false;
	var sortIcon = "";
	if (bcustomSort == true) { //We have already sorted on a custom column (ie: duration)
		//Check if the sort request is for the same column. If so, change the sort direction and resort the grid

		if (customSortCol == args.columnName) {
			resort = true;
			console.log("need to resort");
			if (sortDirection == "ascending") {
				sortDirection = "descending";
				sortIcon = "e-rarrowdown-2x";

			} else {
				sortDirection = "ascending";
				sortIcon = "e-rarrowup-2x";
			}
			//Resort the column and change the sort icon according to the direction
			gridObj.sortColumn(companionCol, sortDirection);

			//Remove one sort icon and replace with the other according to sort direction
			$(gridObj.getHeaderContent().find(".e-headercelldiv")[sortedColIx]).find(".e-icon").remove();
			$(gridObj.getHeaderContent().find(".e-headercelldiv")[sortedColIx]).append("<span class='e-icon " + sortIcon + "'>");

			return;
		} else {
			//If we get here, our previous sorted column was a custom sorted column.
			//Remove the sort icon from the previously sorted column
			var prevSortedColIx = gridObj.getColumnIndexByField(customSortCol);
			$(gridObj.getHeaderContent().find(".e-headercelldiv")[prevSortedColIx]).find(".e-icon").remove();
			customSortCol = args.columnName;
		}
	}

	sortDirection = args.columnSortDirection;
	bcustomSort = true;
	customSortCol = args.columnName;
	gridObj.sortColumn(companionCol, sortDirection);

	if (sortDirection == "ascending") {
		sortIcon = "e-rarrowup-2x";
	} else {
		sortIcon = "e-rarrowdown-2x";
	}

	$(gridObj.getHeaderContent().find(".e-headercelldiv")[sortedColIx]).find(".e-icon").remove();
	$(gridObj.getHeaderContent().find(".e-headercelldiv")[sortedColIx]).append("<span class='e-icon " + sortIcon + "'>");

}

function sumDurations(gridObj) {
	var summaryCols = gridObj.model.summaryRows[0].summaryColumns;
	//Loop through the summary columns in the grid model and find any duration columns
	for (var i = 0; i < summaryCols.length; i++) {
		if (summaryCols[i].displayColumn.indexOf("duration") !== -1) {
			var durColIx = gridObj.getColumnIndexByField(summaryCols[i].displayColumn);
			var gridContent = gridObj.getContentTable();
			var numSumRows = gridContent.find(".e-gridSummaryRows").length;
			if (numSumRows > 0) {
				//get the summary rows
				var sumRows = gridContent.find(".e-gridSummaryRows");
				for (var row = 0; row < sumRows.length; row++) {
					//Pass the total seconds that was placed in the summary column via the displayMember method in summaryRows
					//to a function that converts the seconds back to total hours, minutes and seconds
					var durSubtotal = createDurSubtotal(sumRows[row].cells[durColIx].textContent);
					//Update the content of the cell using the value returned from the function
					sumRows[row].cells[durColIx].textContent = durSubtotal;
				}
			}
		}
	}
}
function contextopen(args){
	
	//Remove the custom subMenu so it can be re-populated with the current
	//hidden columns each time the context menu is opened.
	$(".e-customhidesub").remove();
	
	var context = $("#" + this._id + "_Context");
	
	//We only want to display the context menu when right clicking on the column
	//headers so determine if the click is on a headercell and set the visability 
	//accordingly
	
	if (!args.target.className.includes("e-headercell")){
		$("#" + this._id + "_Context").css('visibility', 'hidden');	
	}else{
		$("#" + this._id + "_Context").css('visibility', 'visible');	
	}
	
	var contextSub = $("#" + this._id + "_subMenuContext0");;
	var cols = args.model.columns;
	var companionCols = getCompanionCols(cols,this);
	var hiddenCols = this.getHiddenColumnNames();
	var isCompanion = false;
	for (var i = 0; i < hiddenCols.length; i++){
		var colField = this.getColumnByHeaderText(hiddenCols[i]).field;
		//If the column is a companion column, we do not want to add it to the list
		//since companions are used for functionality only
		for (var j = 0; j< companionCols.length; j++){
			if (colField == companionCols[j]){
				isCompanion = true;	
				break;
			}else{
				isCompanion = false;
			}
		}
		//Add the hidden (non-companion) columns to the Unhide sub menu
		if (!isCompanion){
			var label = hiddenCols[i].replace("<BR>"," ");
			contextSub.append("<li role='menuitem' style='display: block;' class='e-customitem e-customhidesub e-list'><a>" + label + "<span class='e-gridcontext e-icon e-contexttst3'></span></a></li>");
		}
	}
	
	//The logic in the java code used to create the field names uses the column name
	//converted to lowercase with the tags and spaces removed. Use the same logic
	//to identify the field we are going to hide.
	
	//var gridObj = $("#" + this._id).ejGrid("instance");
	
	//Get the headerText from the innerHTML of the target. I tried using the textcontent
	//and the getColumnByField but getColumnByField came back null even if I tried using the 
	//function and manually specifying the field. Sounds like a bug
	contextTarget = args.target.innerHTML;
	
	//Remove the span info so we can get the headerText only and pass it to the getColumnByHeaderText
	//since that function does return the column object. Also, the innerHTML shows the BR tag as lowercase
	//so we need to convert it to uppercase so it matches the headerText.
	contextTarget = (contextTarget.substring(0,contextTarget.indexOf("<span")).replace("<br>","<BR>"));

	
	}
function getCompanionCols(cols,gridObj){
	
	var compaionCount = 0;
	var companionCols = [];
	for (var i = 0; i<cols.length; i++){
		if (!ej.isNullOrUndefined(gridObj.getColumnByIndex(i).customAttributes.companioncol)){
			companionCols.push(gridObj.getColumnByIndex(i).customAttributes.companioncol);
		}
	}
	return companionCols;
}
function isCompanionCol(colField,gridObj){
	if (!ej.isNullOrUndefined(gridObj.getColumnByHeaderText(colField).customAttributes.companioncol)){
		
	}
	
}

function contextclick(args){
	//var gridCount = 0;
	var grids = [];
	for (var i = 0; i < 5; i++){
		var grid = $("#Grid" + i);
		if (grid.length > 0){
			grids.push("#Grid" +i);
			//gridCount++;
		}
	}
	var colHeader = this.getColumnByHeaderText(contextTarget);
	var columns = args.model.columns;
	if (args.text == "Hide Column"){
		this.hideColumns(contextTarget);
	}
	if (args.parentText == "Unhide Column"){
		var requestedColumn = args.text;
		for (var i =0; i< columns.length; i++){
			var colHeader = columns[i].headerText;
			var colHeaderNoHTML = colHeader.replace("<BR>"," ");
			if (colHeaderNoHTML == requestedColumn){
				this.showColumns(colHeader);
				break;
			}
			
		}
	}
	if (args.text == "Export to PDF"){
		alert("length = " + grids.length);
		if (grids.length > 1){
		    ej.Grid.exportAll("/api/Values/MultiplePDFExport", true, ['#Grid0', '#Grid1']);
		}else{
		    this.export("/api/Values/PdfExport");
		}
	}
	if (args.text == "Export to Excel"){
		if (grids.length > 1){
			//var gridObj = $("#Grid0").data("ejGrid");
			//ej.Grid.exportAll("/ServerOperations/api/Orders/MultipleExcelExport",null,true,['#Grid0', '#Grid1']);
		    ej.Grid.exportAll("/api/Values/MultipleExcelExport", true, ['#Grid0', '#Grid1']);
			//ej.Grid.exportAll('/ServerOperations/api/Orders/MultipleExcelExport',['#Grid0', '#Grid1']);
		}else{
		    this.export("/api/Values/ExcelExport");
		}
	}
}